<template>
  <div></div>
</template>

<script>
import { imageOverlay, latLngBounds, latLng } from 'leaflet'
import { findParentComponentByName } from '@/core/util'
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

export default {
  name: 'leafletimageoverlaylayer',

  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    identifier: {
      type: Number,
      required: true,
    },
  },

  computed: {
    leafletMap: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletmap')
      }
    },

    leafletPane: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletpane')
      }
    },

    // Current status of this layer in the workspace context state
    layerStatus: {
      get() {
        return this.$store.state[this.workspace].layers.find(layer => layer.id === this.identifier).active
      },
    },

    // Layer definition with the proper settings to display the WMS layer object
    layerDefinition: {
      get() {
        return this.$store.getters.getLayerById(this.identifier)
      },
    },

    // The service URL for this layer
    serviceUrl: {
      get() {
        return this.$store.getters.getServiceById(this.layerDefinition.service).url
      },
    },

    // Reference time for the WMS request
    referenceTime: {
      get() {
        return this.$store.state[this.workspace].referenceTime
      },
    },

    // Current step used to compute the time paramenter for the WMS request
    step: {
      get() {
        return this.$store.state[this.workspace].step
      },
    },
  },

  methods: {
    create() {
      this.layerObject = imageOverlay(this.serviceUrl, this.getBounds(), this.getOptions())
      return this
    },

    getBounds() {
      return latLngBounds( new latLng(34.011513, -12.454795), new latLng(43.792862, -4.345465));
    }

    getOptions() {
      return {
        opacity: 0.8
      }
    },

    add() {
      this.layerObject.addTo(this.leafletMap.mapObject)
      return this
    },

    remove() {
      this.layerObject.remove()
      return this
    },
  }
}
</script>
